#ifndef INCLUDED_SOCKET
#define INCLUDED_SOCKET

/* Needed on OSF/1 in order to avoid a redefinition of gethostid */
#undef _OSF_SOURCE

#ifdef HAVE_SYS_TYPE_H
# include <sys/types.h>
#endif
#ifdef HAVE_SYS_SOCKET_H
# include <sys/socket.h>
#endif
#include "n_time.h"
#ifdef HAVE_NETINET_IN_H
# include <netinet/in.h>
#endif
#ifdef HAVE_ARPA_INET_H
# ifndef HPSUX7_KLUDGES
#  include <arpa/inet.h>
# endif
#endif
#ifdef HAVE_SYS_PARAM_H
# include <sys/param.h>
#endif
#ifdef HAVE_SYS_UIO_H
# include <sys/uio.h>
#endif
#ifdef HAVE_NETINET_IN_SYSTM_H
# include <netinet/in_systm.h>
#endif
#ifdef HAVE_NETINET_IN_SYSTEM_H
# include <netinet/in_system.h>
#endif
#ifdef HAVE_NETINET_IP_H
# include <netinet/ip.h>
#endif
#ifdef HAVE_NETINET_TCP_H
# include <netinet/tcp.h>
#endif
#ifdef HAVE_NETINET_UDP_H
# include <netinet/udp.h>
#endif
#ifdef IPV6_SUPPORT
# ifdef HAVE_LINUX_IPV6_H
#  include <linux/ipv6.h>
# endif
# ifdef HAVE_NETINET_IP6_H
#  include <netinet/ip6.h>
# endif
#endif
#include <netdb.h>
#ifdef HAVE_SELECT_H
# include <select.h>
#else
# ifdef HAVE_SYS_SELECT_H
#  include <sys/select.h>
# endif
#endif
#include <fcntl.h>
#ifdef HAVE_SYS_WAIT_H
# include <sys/wait.h>
#endif
#ifdef HAVE_NET_IF_H
# include <net/if.h>
#endif
#ifdef HAVE_ARPA_NAMESER_H
# include <arpa/nameser.h>
#endif
#ifdef HAVE_RESOLV_H
# include <resolv.h>
#endif

#ifdef BROKEN_INET_ADDR
# define inet_addr inet_network
#endif

#ifndef TCP_NODELAY
# define TCP_NODELAY 1
#endif

#ifndef INADDR_NONE
# define INADDR_NONE 0xffffffff
#endif

#ifndef CONF_MAXFD
# define CONF_MAXFD 256
#endif

#ifndef CONF_TCP_SO_RCVBUF
# define CONF_TCP_SO_RCVBUF 16384
#endif

#ifndef CONF_TCP_SO_SNDBUF
# define CONF_TCP_SO_SNDBUF 16384
#endif

#ifndef CONF_UDP_SO_RCVBUF
# define CONF_UDP_SO_RCVBUF 16384
#endif

#ifndef CONF_UDP_SO_SNDBUF
# define CONF_UDP_SO_SNDBUF 16384
#endif

#endif
