#ifndef INCLUDED_TOOLS
#define INCLUDED_TOOLS

#include "n_regex.h"

enum {
   TOOLS_MAXPORTSTRINGLEN = 256,
};

#define TOOLS_ENVGAP ((size_t) 8)

enum {
   TOOLS_LIMIT_CPU,
   TOOLS_LIMIT_FSIZE,
   TOOLS_LIMIT_DATA,
   TOOLS_LIMIT_STACK,
   TOOLS_LIMIT_CORE,
   TOOLS_LIMIT_RSS,
   TOOLS_LIMIT_NPROC,
   TOOLS_LIMIT_NOFILE,
   TOOLS_LIMIT_MEMLOCK
};

char *tools_servicenametxt(const ServiceContext * const servicecontext);
void tools_cleanenv(void);
int tools_changeid(const char * const user, const char * const group);
int tools_namesmatchrx(const char **names, regex_t *rx);
const char *tools_seeipoptions(const SockEvent * const event);
int tools_initdaemon(void);
int tools_setlimit(const int limitnb, long value);
int tools_putenv(const char * const envar, const char * const what);
int tools_setucspienv(const SocketInfo * const socketinfo);
int tools_set_cloexec_flag(int desc, int value);

#endif
